<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex28.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex28.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex28.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex28.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 28: Boolean Practice</h1>
                <p>The logic combinations you learned from the last exercise are called &quot;boolean&quot; logic expressions.  Boolean logic is used <em>everywhere</em> in programming.  It is a fundamental part of computation and knowing them very well is akin to knowing your scales in music.</p>
<p>In this exercise you will take the logic exercises you memorized and start trying them out in Python.  Take each of these logic problems and write what you think the answer will be.  In each case it will be either True or False.  Once you have the answers written down, you will start Python in your Terminal and type each logic problem in to confirm your answers.</p>
<ol class="arabic simple">
<li><tt class="docutils literal">True and True</tt></li>
<li><tt class="docutils literal">False and True</tt></li>
<li><tt class="docutils literal">1 == 1 and 2 == 1</tt></li>
<li><tt class="docutils literal">&quot;test&quot; == &quot;test&quot;</tt></li>
<li><tt class="docutils literal">1 == 1 or 2 != 1</tt></li>
<li><tt class="docutils literal">True and 1 == 1</tt></li>
<li><tt class="docutils literal">False and 0 != 0</tt></li>
<li><tt class="docutils literal">True or 1 == 1</tt></li>
<li><tt class="docutils literal">&quot;test&quot; == &quot;testing&quot;</tt></li>
<li><tt class="docutils literal">1 != 0 and 2 == 1</tt></li>
<li><tt class="docutils literal">&quot;test&quot; != &quot;testing&quot;</tt></li>
<li><tt class="docutils literal">&quot;test&quot; == 1</tt></li>
<li><tt class="docutils literal">not (True and False)</tt></li>
<li><tt class="docutils literal">not (1 == 1 and 0 != 1)</tt></li>
<li><tt class="docutils literal">not (10 == 1 or 1000 == 1000)</tt></li>
<li><tt class="docutils literal">not (1 != 10 or 3 == 4)</tt></li>
<li><tt class="docutils literal">not (&quot;testing&quot; == &quot;testing&quot; and &quot;Zed&quot; == &quot;Cool Guy&quot;)</tt></li>
<li><tt class="docutils literal">1 == 1 and (not (&quot;testing&quot; == 1 or 1 == 0))</tt></li>
<li><tt class="docutils literal">&quot;chunky&quot; == &quot;bacon&quot; and (not (3 == 4 or 3 == 3))</tt></li>
<li><tt class="docutils literal">3 == 3 and (not (&quot;testing&quot; == &quot;testing&quot; or &quot;Python&quot; == <span class="pre">&quot;Fun&quot;))</span></tt></li>
</ol>
<p>I will also give you a trick to help you figure out the more complicated ones toward the end.</p>
<p>Whenever you see these boolean logic statements, you can solve them easily by this simple process:</p>
<ol class="arabic simple">
<li>Find an equality test (== or !=) and replace it with its truth.</li>
<li>Find each <tt class="docutils literal">and/or</tt> inside parentheses and solve those first.</li>
<li>Find each <tt class="docutils literal">not</tt> and invert it.</li>
<li>Find any remaining <tt class="docutils literal">and/or</tt> and solve it.</li>
<li>When you are done you should have True or False.</li>
</ol>
<p>I will demonstrate with a variation on #20:</p>
<pre class="code python literal-block">
<span class="literal number integer">3</span> <span class="operator">!=</span> <span class="literal number integer">4</span> <span class="operator word">and</span> <span class="operator word">not</span> <span class="punctuation">(</span><span class="literal string double">&quot;testing&quot;</span> <span class="operator">!=</span> <span class="literal string double">&quot;test&quot;</span> <span class="operator word">or</span> <span class="literal string double">&quot;Python&quot;</span> <span class="operator">==</span> <span class="literal string double">&quot;Python&quot;</span><span class="punctuation">)</span>
</pre>
<p>Here's me going through each of the steps and showing you the translation until I've boiled it down to a single result:</p>
<ol class="arabic">
<li><p class="first">Solve each equality test:</p>
<blockquote>
<p><tt class="docutils literal">3 != 4</tt> is <tt class="docutils literal">True</tt>: <tt class="docutils literal">True and not (&quot;testing&quot; != &quot;test&quot; or &quot;Python&quot; == &quot;Python&quot;)</tt>
<tt class="docutils literal">&quot;testing&quot; != &quot;test&quot;</tt> is <tt class="docutils literal">True</tt>: <tt class="docutils literal">True and not (True or &quot;Python&quot; == &quot;Python&quot;)</tt>
<tt class="docutils literal">&quot;Python&quot; == &quot;Python&quot;</tt>: <tt class="docutils literal">True and not (True or True)</tt></p>
</blockquote>
</li>
<li><p class="first">Find each <tt class="docutils literal">and/or</tt> in parentheses ():</p>
<blockquote>
<p><tt class="docutils literal">(True or True)</tt> is True: <tt class="docutils literal">True and not (True)</tt></p>
</blockquote>
</li>
<li><p class="first">Find each <tt class="docutils literal">not</tt> and invert it:</p>
<blockquote>
<p><tt class="docutils literal">not (True)</tt> is False: <tt class="docutils literal">True and False</tt></p>
</blockquote>
</li>
<li><p class="first">Find any remaining <tt class="docutils literal">and/or</tt> and solve them:</p>
<blockquote>
<p><tt class="docutils literal">True and False</tt> is False</p>
</blockquote>
</li>
</ol>
<p>With that we're done and know the result is False.</p>
<div class="warning">
<p class="first admonition-title">Warning</p>
<p class="last">The more complicated ones may seem <em>very</em> hard at first.  You should be able to give a good first stab at solving them, but do not get discouraged.  I'm just getting you primed for more of these &quot;logic gymnastics&quot; so that later cool stuff is much easier.  Just stick with it, and keep track of what you get wrong, but do not worry that it's not getting in your head quite yet.  It'll come.</p>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<p>After you have tried to guess at these, this is what your session with Python might look like:</p>
<pre class="code pycon literal-block">
<span class="generic output">$ python
Python 2.5.1 (r251:54863, Feb  6 2009, 19:02:12)
[GCC 4.0.1 (Apple Inc. build 5465)] on darwin
Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.
</span><span class="name builtin pseudo"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="name builtin pseudo">True</span> <span class="operator word">and</span> <span class="name builtin pseudo">True</span>
<span class="generic output">True
</span><span class="literal number integer"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="literal number integer">1</span> <span class="operator">==</span> <span class="literal number integer">1</span> <span class="operator word">and</span> <span class="literal number integer">2</span> <span class="operator">==</span> <span class="literal number integer">2</span>
<span class="generic output">True</span>
</pre>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>There are a lot of operators in Python similar to <tt class="docutils literal">!=</tt> and <tt class="docutils literal">==</tt>.  Try to find as many &quot;equality operators&quot; as you can.  They should be like <tt class="docutils literal">&lt;</tt> or <tt class="docutils literal">&lt;=</tt>.</li>
<li>Write out the names of each of these equality operators.  For example, I call <tt class="docutils literal">!=</tt> &quot;not equal.&quot;</li>
<li>Play with the Python by typing out new boolean operators, and before you press Enter try to shout out what it is.  Do not think about it. Shout the first thing that comes to mind.  Write it down, then press Enter, and keep track of how many you get right and wrong.</li>
<li>Throw away the piece of paper from 3 away so you do not accidentally try to use it later.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>Why does <tt class="docutils literal">&quot;test&quot; and &quot;test&quot;</tt> return <tt class="docutils literal">&quot;test&quot;</tt> or <tt class="docutils literal">1 and 1</tt> return <tt class="docutils literal">1</tt> instead of <tt class="docutils literal">True</tt>?</dt>
<dd>Python and many languages like to return one of the operands to their boolean expressions rather than just <tt class="docutils literal">True</tt> or <tt class="docutils literal">False</tt>.  This means that if you did <tt class="docutils literal">False and 1</tt> you get the first operand (<tt class="docutils literal">False</tt>) but if you do <tt class="docutils literal">True and 1</tt> your get the second (<tt class="docutils literal">1</tt>). Play with this a bit.</dd>
<dt>Is there any difference between <tt class="docutils literal">!=</tt> and <tt class="docutils literal">&lt;&gt;</tt>?</dt>
<dd>Python has deprecated <tt class="docutils literal">&lt;&gt;</tt> in favor of <tt class="docutils literal">!=</tt>, so use <tt class="docutils literal">!=</tt>. Other than that there should be no difference.</dd>
<dt>Isn't there a shortcut?</dt>
<dd>Yes. Any <tt class="docutils literal">and</tt> expression that has a <tt class="docutils literal">False</tt> is immediately <tt class="docutils literal">False</tt>, so you can stop there.  Any <tt class="docutils literal">or</tt> expression that has a <tt class="docutils literal">True</tt> is immediately <tt class="docutils literal">True</tt>, so you can stop there. But make sure that you can process the whole expression because later it becomes helpful.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex28.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex28.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
